package com.biganto.visual.roompark.presentation.screen.auth

import android.content.Context
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.AuthContractModule
import com.biganto.visual.roompark.di.dagger.PerScreen
import com.biganto.visual.roompark.domain.contract.AuthContract
import dagger.Binds
import dagger.BindsInstance
import dagger.Component
import dagger.Module


@PerScreen
@Component(
    modules = [AuthScreenModule::class],
    dependencies = [AppComponent::class])
interface AuthScreenComponent {

    @Component.Factory
    interface Factory{
        fun create(
            appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
        ): AuthScreenComponent
    }

    val presenter: AuthScreenPresenter

    fun inject(controller: AuthScreenController)
}

@Module
abstract class AuthScreenModule{

    @PerScreen
    @Binds
   abstract fun provideContext(activity: RoomParkMainActivity): Context

    @PerScreen
    @Binds
    abstract fun provideAuth(contract: AuthContractModule): AuthContract
}
